from cpl_core.logging import LoggerABC
from discord.ext import commands

from gismo_core.abc.bot_service_abc import BotServiceABC
from gismo_core.configuration.bot_settings import BotSettings
from gismo_core.configuration.discord_settings import DiscordSettings


class BotService(BotServiceABC, commands.Bot):

    def __init__(self, logger: LoggerABC, discord_settings: DiscordSettings, bot_settings: BotSettings):
        self._logger = logger
        self._discord_settings = discord_settings
        self._bot_settings: BotSettings = bot_settings
        # setup self
        commands.Bot.__init__(self, command_prefix=bot_settings.prefix, help_command=None)

    async def start_async(self):
        self.run(self._discord_settings.token)

    async def stop_async(self):
        try:
            pass
            # save data
        except Exception as e:
            self._logger.error(__name__, 'Stop failed', e)
